var canvas;
var ctx;
var timerActive = false;
var pixelR = 0;
var pixelG = 0;
var pixelB = 0;
var pixelRold = 0;
var pixelGold = 0;
var pixelBold = 0;
var repeats = 0;
var skipSend = false;


var images = [ // predefined array of used images
    'images/pic1.jpg',
];
var iActiveImage = 0;

$(function(){

    // drawing active image
    var image = new Image();
    image.onload = function () {
        ctx.drawImage(image, 0, 0, image.width, image.height); // draw the image on the canvas
    }

    image.src = images[iActiveImage];


	idInstanzID = document.getElementById("InstanzID").innerHTML;
	idRGBFaderID = document.getElementById("RGBFaderID").innerHTML;
	idProgrammID = document.getElementById("ProgrammID").innerHTML;
	idFesteFarben = document.getElementById("idFesteFarben").innerHTML;
	idFadeTimerID = document.getElementById("FadeTimerID").innerHTML;
	idRGBWAutomatikFarbWertID = document.getElementById("RGBWAutomatikFarbWertID").innerHTML;
	idRGBWManuellFarbWertID = document.getElementById("RGBWManuellFarbWertID").innerHTML;
	idRGBWManuellFarbWertWeissID = document.getElementById("RGBWManuellFarbWertWeissID").innerHTML;
	idVariablenprofilID = document.getElementById("VariablenprofilID").innerHTML;

    // creating canvas object
    canvas = document.getElementById('panel');
    ctx = canvas.getContext('2d');

    $('#panel').mousemove(function(e) { // mouse move handler
        var canvasOffset = $(canvas).offset();
        var canvasX = Math.floor(e.pageX - canvasOffset.left);
        var canvasY = Math.floor(e.pageY - canvasOffset.top);

        var imageData = ctx.getImageData(canvasX, canvasY, 1, 1);
        var pixel = imageData.data;

        var pixelColor = "rgba("+pixel[0]+", "+pixel[1]+", "+pixel[2]+", "+pixel[3]+")";
        $('#preview').css('backgroundColor', pixelColor);
		pixelR = pixel[0];
		pixelG = pixel[1];
		pixelB = pixel[2];
    });
	
    $('#panel').click(function(e) { // mouse click handler
        var canvasOffset = $(canvas).offset();
        var canvasX = Math.floor(e.pageX - canvasOffset.left);
        var canvasY = Math.floor(e.pageY - canvasOffset.top);

        var imageData = ctx.getImageData(canvasX, canvasY, 1, 1);
        var pixel = imageData.data;

		pixelR = pixel[0];
		pixelG = pixel[1];
		pixelB = pixel[2];
		
		
		if(timerActive) {
			timerActive = false;
			$(this).stopTime('updatergb');
		} else {
			timerActive = true;
			repeats = 0;
			$(this).everyTime(250,'updatergb',function(){
				if(pixelR == pixelRold && pixelG == pixelGold && pixelB == pixelBold){
					repeats++;
					skipThis = true;
				} else {
					repeats = 0;
					pixelRold = pixelR;
					pixelGold = pixelG;
					pixelBold = pixelB;	
				}
				if(repeats <= 5) {
					if(!skipThis) {
						xhReq = new XMLHttpRequest;
						xhReq.open("POST","ImageColorPicker-receive.php",true);
						xhReq.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
						action = "r=" + pixelR;
						action += "&g=" + pixelG;
						action += "&b=" + pixelB;
						action += "&idInstanzID=" + idInstanzID;
						action += "&idRGBFaderID=" + idRGBFaderID;
						action += "&idProgrammID=" + idProgrammID;
						action += "&idFesteFarben=" + idFesteFarben;
						action += "&idFadeTimerID=" + idFadeTimerID;
						action += "&idRGBWAutomatikFarbWertID=" + idRGBWAutomatikFarbWertID;
						action += "&idRGBWManuellFarbWertID=" + idRGBWManuellFarbWertID;
						action += "&idRGBWManuellFarbWertWeissID=" + idRGBWManuellFarbWertWeissID;
						action += "&idVariablenprofilID=" + idVariablenprofilID;
						xhReq.send(action);
						skipThis = false;
					} else {
						skipThis = false;
					}
				} else {
					repeats = 0;
					timerActive = false;
					skipThis = false;
					$(this).stopTime('updatergb');	
				}
				});
		}
    });
});